include gdiplus.inc
includelib gdiplus.lib

   GdiplusStartupInput STRUCT
      GdiplusVersion           DWORD ?
      DebugEventCallback       DWORD ?
      SuppressBackgroundThread DWORD ?
      SuppressExternalCodecs   DWORD ?
    GdiplusStartupInput ENDS

    ImageCodecInfo STRUCT
      ClassID           CLSID <>
      FormatID          GUID <>
      CodecName         DWORD ?
      DllName           DWORD ?
      FormatDescription DWORD ?
      FilenameExtension DWORD ?
      MimeType          DWORD ?
      Flags             DWORD ?
      Version           DWORD ?
      SigCount          DWORD ?
      SigSize           DWORD ?
      SigPattern        DWORD ?
      SigMask           DWORD ?
    ImageCodecInfo ENDS
.data
ALIGN 16
Sprite_Simd_Mask_RVB_unpck_1 DWORD 000010001h,000000001h
Sprite_Simd_Mask_RVB_unpck_255 DWORD 000FF00FFh,0000000FFh
   
.data?
      token               dd 0
      image               dd 0
      numEncoders         dd 0
      sizeImageCodecInfo  dd 0
      pImageCodecInfo     dd 0
      gdipsi              GdiplusStartupInput <1>  ; version must be 1

.code

IsInsidePolygon proc uses esi edi x:dword,y:dword,lpPoints:dword,nPointCounts:dword
	LOCAL i,j:dword
	LOCAL oddNodes,logic,logic2,logic3,logic4:dword
;	bool pointInPolygon() {
;
 ; int      i, j=polySides-1 ;
  ;boolean  oddNodes=NO      ;
;
;  for (i=0; i<polySides; i++) {
;    if (polyY[i]<y && polyY[j]>=y
;    ||  polyY[j]<y && polyY[i]>=y) {
;      if (polyX[i]+(y-polyY[i])/(polyY[j]-polyY[i])*(polyX[j]-polyX[i])<x) {
;        oddNodes=!oddNodes; }}
;    j=i; }
;  return oddNodes; }
	
	push nPointCounts
	pop j
	dec j
	
	mov esi,lpPoints
	
	xor eax,eax
	mov i,eax
	mov oddNodes,eax
	loop_i:
		xor eax,eax
		mov logic,eax
		mov logic2,eax
		mov logic3,eax
		mov logic4,eax
		
		mov eax,i
		shl eax,3
		mov ecx,[esi+eax].POINT.y		; polyY[i]<y
		cmp ecx,y
		jnl logic1_not_set
			mov logic,1
		logic1_not_set:
			mov eax,j
			shl eax,3
			mov ecx,[esi+eax].POINT.y	; polyY[j]>=y
			cmp ecx,y
			jnae logic2_not_set
				mov logic2,1
			logic2_not_set:
				mov eax,j
				shl eax,3
				mov ecx,[esi+eax].POINT.y	 ;polyY[j]<y
				cmp ecx,y
				jnl logic3_not_set
					mov logic3,1
				logic3_not_set:
					mov eax,i
					shl eax,3
					mov ecx,[esi+eax].POINT.y		; POINT.y
					cmp ecx,y
					jnae logic4_not_set
						mov logic4,1
					logic4_not_set:
						;polyY[i]<y && polyY[j]>=y
						mov eax,logic
						and eax,logic2
						;polyY[j]<y && polyY[i]>=y
						mov ecx,logic3
						and ecx,logic4
						;polyY[i]<y && polyY[j]>=y || polyY[j]<y && polyY[i]>=y
						or eax,ecx
						jz pol_i
						;      if (polyX[i]+(y-polyY[i])/(polyY[j]-polyY[i])*(polyX[j]-polyX[i])<x)
						; (y-polyY[i]
						push y
							mov eax,i
							shl eax,3
							mov ecx,[esi+eax].POINT.y
							sub dword ptr [esp],ecx
						pop ecx	
						add ecx,[esi+eax].POINT.x
						; (polyY[j]-polyY[i])*(polyX[j]-polyX[i]
						push ecx
							mov eax,j
							shl eax,3
							mov ecx,[esi+eax].POINT.y		; polyY[j]
							mov eax,i
							shl eax,3
							sub ecx,[esi+eax].POINT.y		; polyY[j]-polyY[i]
							push ecx
								mov eax,j
								shl eax,3
								mov ecx,[esi+eax].POINT.x	;  polyX[j]
								mov eax,i
								shl eax,3
								sub ecx,[esi+eax].POINT.x	;	polyX[j]-polyX[i]
							pop eax
							mul ecx
						pop ecx
						xchg ecx,eax						; 	ecx = (polyY[j]-polyY[i])*(polyX[j]-polyX[i])
															;	eax = (polyX[i]+(y-polyY[i])
						cmp eax,0
						jz zero_result
							cmp ecx,0
							jz zero_result
								div ecx
								jmp compare_with_x
						zero_result:
							xor eax,eax
						compare_with_x:
							mov ecx,x
							cmp eax,x
							jnl pol_i
								not oddNodes
		pol_i:
	push i
	pop j
	inc i
	mov eax,nPointCounts
	cmp i,eax
	jl loop_i
	
	mov eax,oddNodes
	
	ret
IsInsidePolygon endp

nwBlendPixel proc pixel:dword,pixel2:dword,percent:dword

; NightWare algo from www.masm32.com

	mov eax,percent ; 0 to 100
	mov edx,0FFh
	mul edx
	mov edx,42949673
	mul edx ; become 0 to 255 in edx
	
	shl edx,24 ; A,_,_,_
	
	mov eax,pixel ; _,R,G,B read pixel
	or eax,edx ; A,R,G,B add alpha
	mov edx,pixel2 ; _,R,G,B read pixel2
	
	pxor MM7,MM7 ; MM7 = 0,0,0,0 , 0,0,0,0
	movq MM6,QWORD PTR Sprite_Simd_Mask_RVB_unpck_1 ; MM6 = 0,0,0,1 , 0,1,0,1
	movd MM1,eax ; MM1 = _,_,_,_ , A,R,G,B (pixel)
	movd MM0,edx ; MM0 = _,_,_,_ , A,R,G,B (pixel2)
	punpcklbw MM1,MM7 ; MM1 = 0,A,0,R , 0,G,0,B
	punpcklbw MM0,MM7 ; MM0 = 0,A,0,R , 0,G,0,B
	movq MM2,MM1 ; MM2 = 0,A,0,R , 0,G,0,B
	pshufw MM2,MM2,0FFh ; MM2 = 0,A,0,A , 0,A,0,A
	movq MM3,QWORD PTR Sprite_Simd_Mask_RVB_unpck_255 ; MM3 = 0,0,0,255 , 0,255,0,255
	psubw MM3,MM2 ; MM3 = 0,~A,0,~A , 0,~A,0,~A
	paddw MM2,MM6 ; MM2 = 0,A+1,0,A+1 , 0,A+1,0,A+1
	paddw MM3,MM6 ; MM3 = 0,~A+1,0,~A+1 , 0,~A+1,0,~A+1
	pmullw MM1,MM2 ; MM1 = A*A,R*A , G*A,B*A
	pmullw MM0,MM3 ; MM0 = A*0,R*A , G*A,B*A
	paddw MM0,MM1 ; MM0 = A*0+A*0,R*A+R*A , G*A+G*A,B*A+B*A
	psrlw MM0,8 ; MM0 = 0,A,0,R , 0,G,0,B
	packuswb MM0,MM7 ; MM0 = _,_,_,_ , A,R,G,B
	movd eax,MM0 ; A,R,G,B new
	emms
	and eax,000FFFFFFh ; _,R,G,B only keep RGB

ret
nwBlendPixel endp

MakeFont proc pointSize:DWORD,weight:DWORD,italic:DWORD,lpFontName:DWORD

    invoke GetDC, 0
    invoke GetDeviceCaps,eax,LOGPIXELSY
    mul pointSize
    xor edx, edx
    mov ecx, 72
    div ecx

    invoke CreateFont,eax,0,NULL,NULL,weight,italic,NULL,NULL,
                      DEFAULT_CHARSET,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,
                      PROOF_QUALITY,DEFAULT_PITCH or FF_DONTCARE,
                      lpFontName
    ret
MakeFont endp

fNewLayer proc uses esi lpLayerStruct:dword,_width:dword,height:dword
	
	mov esi,lpLayerStruct
	invoke CreateCompatibleDC,0
	.if eax==0
		invoke MessageBox,0,0,0,0
	.endif
	mov [esi].fLayer.DC,eax
	invoke CreateIndependantBitmap,eax,_width,height
	mov [esi].fLayer.bmp,eax
	invoke SelectObject,[esi].fLayer.DC,[esi].fLayer.bmp
	invoke DeleteObject,eax
	
	
	ret
fNewLayer endp

fDeleteLayer proc uses esi lpLayerStruct:dword
	
	mov esi,lpLayerStruct
	invoke DeleteObject,[esi].fLayer.bmp
	invoke DeleteDC,[esi].fLayer.DC
	
	ret
fDeleteLayer endp

fSaveDCAsBitmap proc uses esi edi DC:dword,lpFileName:dword,_width:dword,height:dword
	LOCAL hmem:dword
	LOCAL tmpDC,mainDC,mBmp,hFile:dword
	
	invoke GetDC,0
	mov tmpDC,eax
	
	invoke CreateIndependantBitmap,tmpDC,_width,height
	mov mBmp,eax
	
	invoke CreateCompatibleDC,tmpDC
	mov mainDC,eax
	
	invoke ReleaseDC,0,tmpDC
	invoke SelectObject,mainDC,mBmp
	
	invoke BitBlt,mainDC,0,0,_width,height,DC,0,0,SRCCOPY
	
	invoke CreateFile,lpFileName,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,NULL,NULL
	mov hFile,eax
	
	invoke SaveDIB32,mBmp,hFile
	
	invoke CloseHandle,hFile
	
	invoke DeleteDC,mainDC
	invoke DeleteObject,mBmp
	
	
	
	ret
fSaveDCAsBitmap endp

fPicSaveToFileAsJpg proc uses esi edi lpFileName:dword
   LOCAL str_len,tmp_esi:dword
   LOCAL buff[256],buff2[256],buff3[256]:dword
   
   invoke exist,lpFileName
   .if eax==0
      invoke MessageBox,0,0,0,0
      ret
   .endif
   
   invoke GdiplusStartup, ADDR token, ADDR gdipsi, NULL
      invoke MultiByteToWideChar,0,0,lpFileName,-1,addr buff3,1024
      invoke GdipLoadImageFromFile, addr buff3, ADDR image
      invoke GdipGetImageEncodersSize, ADDR numEncoders,ADDR sizeImageCodecInfo
      invoke mAlloc,sizeImageCodecInfo
      .if eax==0
         invoke MessageBox,0,CADD("Not Enough memory/Memori tidak cukup"),0,0
         jmp error
      .endif
      mov pImageCodecInfo,eax
      invoke GdipGetImageEncoders, numEncoders, sizeImageCodecInfo,pImageCodecInfo
            invoke lstrlen,lpFileName
            mov str_len,eax
            sub str_len,2
            invoke lstrcpyn,addr buff,lpFileName,str_len
            invoke lstrcat,addr buff,CADD("jpg")
            
            assume esi:ptr ImageCodecInfo
               mov ecx,numEncoders
               mov esi,pImageCodecInfo
               @@:
               push ecx
               push esi
               mov tmp_esi,esi
               invoke WideCharToMultiByte,0,0,[esi].MimeType,-1,addr buff2,1024,0,0
               invoke lstrcmp,addr buff2,CADD("image/jpeg")
               .if eax==0
                  invoke MultiByteToWideChar,0,0,addr buff,-1,addr buff3,1024
                  invoke GdipSaveImageToFile, image, addr buff3,tmp_esi, NULL
                  pop esi
                  pop ecx
                  jmp error
               .endif
               pop esi
               add esi, SIZEOF ImageCodecInfo
               pop ecx
               dec ecx
               jnz @b
            assume esi:nothing
      
      error:      
   invoke GdipDisposeImage, image
   invoke GdiplusShutdown, token
   invoke GlobalFree,pImageCodecInfo
   
   ret
fPicSaveToFileAsJpg endp

fLoadPicture proc lpFileName:dword,DC:dword
	LOCAL buff[512],hMemDC,hBitmap,mptr,err_code:dword
	LOCAL file_size:dword
	LOCAL bm:BITMAP
	LOCAL tmpDC:dword
		
		mov err_code,0
		invoke exist,lpFileName
		.if eax!=1
			invoke GetAppPath,addr buff
			invoke lstrcat,addr buff,lpFileName
			invoke exist,addr buff
			.if eax!=1
				xor eax,eax
				dec eax
				ret
			.endif
		.endif
		
		invoke filesize,lpFileName
		mov file_size,eax
		invoke mAlloc,eax
		mov mptr,eax
		invoke Open,mptr,lpFileName,addr err_code,file_size
		invoke BitmapFromMemory,mptr,file_size
		.if eax==0
			invoke PERR
			invoke MessageBox,NULL,lpFileName,NULL,MB_OK
			xor eax,eax
			dec eax
			ret
		.endif
		mov	hBitmap,eax
		invoke GlobalFree,mptr
		
		invoke CreateCompatibleDC,0
		mov tmpDC,eax
		push eax
		invoke SelectObject,tmpDC,hBitmap
		invoke DeleteObject,eax
		
		invoke GetObject,hBitmap,sizeof BITMAP,addr bm
		
		invoke BitBlt,DC,0,0,bm.bmWidth,bm.bmHeight,tmpDC,0,0,SRCCOPY
		invoke DeleteDC,tmpDC
		invoke DeleteObject,hBitmap
		pop eax
		xor eax,eax
		
	
	ret
fLoadPicture endp