
STISpRecognizer	STRUCT
		QueryInterface               	dword ?
		AddRef                       	dword ?
		Release                      	dword ?
		SetPropertyNum               	dword ?
		GetPropertyNum               	dword ?
		SetPropertyString            	dword ?
		GetPropertyString            	dword ?
		SetRecognizer                	dword ?
		GetRecognizer                	dword ?
		SetInput                     	dword ?
		GetInputObjectToken          	dword ?
		GetInputStream               	dword ?
		CreateRecoContext            	dword ?
		GetRecoProfile               	dword ?
		SetRecoProfile               	dword ?
		IsSharedInstance             	dword ?
		GetRecoState                 	dword ?
		SetRecoState                 	dword ?
		GetStatus                    	dword ?
		GetFormat                    	dword ?
		IsUISupported                	dword ?
		DisplayUI                    	dword ?
		EmulateRecognition           	dword ?
STISpRecognizer	ENDS

	STISpRecoContext	STRUCT
		QueryInterface               	dword ?
		AddRef                       	dword ?
		Release                      	dword ?
		SetNotifySink                	dword ?
		SetNotifyWindowMessage       	dword ?
		SetNotifyCallbackFunction    	dword ?
		SetNotifyCallbackInterface   	dword ?
		SetNotifyWin32Event          	dword ?
		WaitForNotifyEvent           	dword ?
		GetNotifyEventHandle         	dword ?
		SetInterest						dword  ?
		GetEvents                    	dword ?
		GetInfo                      	dword ?
		GetRecognizer                	dword ?
		CreateGrammar					dword  ?
		GetStatus                    	dword ?
		GetMaxAlternates             	dword ?
		SetMaxAlternates             	dword ?
		SetAudioOptions              	dword ?
		GetAudioOptions              	dword ?
		DeserializeResult            	dword ?
		Bookmark						dword  ?
		SetAdaptationData            	dword ?
		pause1                       	dword ?
		Resume                       	dword ?
		SetVoice                     	dword ?
		GetVoice                     	dword ?
		SetVoicePurgeEvent				dword  ?
		GetVoicePurgeEvent           	dword ?
		SetContextState              	dword ?
		GetContextState              	dword ?
	STISpRecoContext	ENDS

STISpRecoGrammar	STRUCT
		QueryInterface               	dword ?
		AddRef                       	dword ?
		Release                      	dword ?
		ResetGrammar                 	dword ?
		GetRule                      	dword ?
		ClearRule                    	dword ?
		CreateNewState               	dword ?
		AddWordTransition            	dword ?
		AddRuleTransition            	dword ?
		AddResource                  	dword ?
		Commit                       	dword ?
		GetGrammarId                 	dword ?
		GetRecoContext               	dword ?
		LoadCmdFromFile              	dword ?
		LoadCmdFromObject            	dword ?
		LoadCmdFromResource          	dword ?
		LoadCmdFromMemory            	dword ?
		LoadCmdFromProprietaryGrammar 	dword ?
		SetRuleState                 	dword ?
		SetRuleIdState               	dword ?
		LoadDictation                	dword ?
		UnloadDictation              	dword ?
		SetDictationState            	dword ?
		SetWordSequenceData          	dword ?
		SetTextSelection             	dword ?
		IsPronounceable              	dword ?
		SetGrammarState              	dword ?
		SaveCmd                      	dword ?
		GetGrammarState              	dword ?
STISpRecoGrammar	ENDS

	STISpVoice	STRUCT
		QueryInterface               	dword ?
		AddRef                       	dword ?
		Release                      	dword ?
		SetNotifySink                	dword ?
		SetNotifyWindowMessage       	dword ?
		SetNotifyCallbackFunction    	dword ?
		SetNotifyCallbackInterface   	dword ?
		SetNotifyWin32Event          	dword ?
		WaitForNotifyEvent           	dword ?
		GetNotifyEventHandle         	dword ?
		SetInterest						dword  ?
		GetEvents                    	dword ?
		GetInfo                      	dword ?
		SetOutput                    	dword ?
		GetOutputObjectToken         	dword ?
		GetOutputStream              	dword ?
		pause1                       	dword ?
		Resume                       	dword ?
		SetVoice                     	dword ?
		GetVoice                     	dword ?
		Speak                        	dword ?
		SpeakStream                  	dword ?
		GetStatus                    	dword ?
		Skip                         	dword ?
		SetPriority                  	dword ?
		GetPriority                  	dword ?
		SetAlertBoundary             	dword ?
		GetAlertBoundary             	dword ?
		SetRate                      	dword ?
		GetRate                      	dword ?
		SetVolume                    	dword ?
		GetVolume                    	dword ?
		WaitUntilDone                	dword ?
		SetSyncSpeakTimeout          	dword ?
		GetSyncSpeakTimeout          	dword ?
		SpeakCompleteEvent           	dword ?
		IsUISupported                	dword ?
		DisplayUI                    	dword ?
	STISpVoice	ENDS

	STISpRecoResult	STRUCT
		QueryInterface               	dword ?
		AddRef                       	dword ?
		Release                      	dword ?
		GetPhrase                    	dword ?
		GetSerializedPhrase          	dword ?
		GetText                      	dword ?
		Discard                      	dword ?
		GetResultTimes               	dword ?
		GetAlternates                	dword ?
		GetAudio                     	dword ?
		SpeakAudio                   	dword ?
		Serialize                    	dword ?
		ScaleAudio                   	dword ?
		GetRecoContext               	dword ?
	STISpRecoResult	ENDS

SPPHRASEELEMENT	STRUCT
	ulAudioTimeOffset DWORD ?
	ulAudioSizeTime DWORD ?
	ulAudioStreamOffset DWORD ?
	ulAudioSizeBytes DWORD ?
	ulRetainedStreamOffset DWORD ?
	ulRetainedSizeBytes DWORD ?
	pszDisplayText DWORD ?
	pszLexicalForm DWORD ?
	pszPronunciation DWORD ?
	bDisplayAttributes BYTE ?
	RequiredConfidence BYTE ?
	ActualConfidence BYTE ?
	Reserved BYTE ?
	SREngineConfidence DWORD ?
SPPHRASEELEMENT		ENDS



SPPHRASERULE	STRUCT
	pszName DWORD ?
	ulId DWORD ?
	ulFirstElement DWORD ?
	ulCountOfElements DWORD ?
	pNextSibling DWORD ?
	pFirstChild DWORD ?
	SREngineConfidence DWORD ?
	Confidence BYTE ?
SPPHRASERULE		ENDS



;SPPHRASEPROPERTY	STRUCT
;	pszName DWORD ?
;	ulId DWORD ?
;	pszValue DWORD ?
;	vValue VARIANT <> 
;	ulFirstElement DWORD ?
;	ulCountOfElements DWORD ?
;	pNextSibling DWORD ?
;	pFirstChild DWORD ?
;	SREngineConfidence DWORD ?
;	Confidence BYTE ?
;SPPHRASEPROPERTY		ENDS

SPEVENT	STRUCT
	eEventId WORD ?
	elParamType WORD ?
	ulStreamNum DWORD ?
	ullAudioStreamOffset QWORD ?
	wParam DWORD ?
	lParam DWORD ?
SPEVENT		ENDS

	STISpRecoResult	STRUCT
		QueryInterface               	dword ?
		AddRef                       	dword ?
		Release                      	dword ?
		GetPhrase                    	dword ?
		GetSerializedPhrase          	dword ?
		GetText                      	dword ?
		Discard                      	dword ?
		GetResultTimes               	dword ?
		GetAlternates                	dword ?
		GetAudio                     	dword ?
		SpeakAudio                   	dword ?
		Serialize                    	dword ?
		ScaleAudio                   	dword ?
		GetRecoContext               	dword ?
	STISpRecoResult	ENDS

;SPEVENTENUM	UNION
	SPEI_UNDEFINED	EQU 0 
	SPEI_START_INPUT_STREAM	EQU 1 
	SPEI_END_INPUT_STREAM	EQU 2 
	SPEI_VOICE_CHANGE	EQU 3 
	SPEI_TTS_BOOKMARK	EQU 4 
	SPEI_WORD_BOUNDARY	EQU 5 
	SPEI_PHONEME	EQU 6 
	SPEI_SENTENCE_BOUNDARY	EQU 7 
	SPEI_VISEME	EQU 8 
	SPEI_TTS_AUDIO_LEVEL	EQU 9 
	SPEI_TTS_PRIVATE	EQU 15 
	SPEI_MIN_TTS	EQU 1 
	SPEI_MAX_TTS	EQU 15 
	SPEI_END_SR_STREAM	EQU 34 
	SPEI_SOUND_START	EQU 35 
	SPEI_SOUND_END	EQU 36 
	SPEI_PHRASE_START	EQU 37 
	SPEI_RECOGNITION	EQU 38 
	SPEI_HYPOTHESIS	EQU 39 
	SPEI_SR_BOOKMARK	EQU 40 
	SPEI_PROPERTY_NUM_CHANGE	EQU 41 
	SPEI_PROPERTY_STRING_CHANGE	EQU 42 
	SPEI_FALSE_RECOGNITION	EQU 43 
	SPEI_INTERFERENCE	EQU 44 
	SPEI_REQUEST_UI	EQU 45 
	SPEI_RECO_STATE_CHANGE	EQU 46 
	SPEI_ADAPTATION	EQU 47 
	SPEI_START_SR_STREAM	EQU 48 
	SPEI_RECO_OTHER_CONTEXT	EQU 49 
	SPEI_SR_AUDIO_LEVEL	EQU 50 
	SPEI_SR_RETAINEDAUDIO	EQU 51 
	SPEI_SR_PRIVATE	EQU 52 
	SPEI_RESERVED4	EQU 53 
	SPEI_RESERVED5	EQU 54 
	SPEI_RESERVED6	EQU 55 
	SPEI_MIN_SR	EQU 34 
	SPEI_MAX_SR	EQU 55 
	SPEI_RESERVED1	EQU 30 
	SPEI_RESERVED2	EQU 33 
	SPEI_RESERVED3	EQU 63 
;SPEVENTENUM		ENDS

SPFEI_FLAGCHECK	equ	<( 1ui64 SHL SPEI_RESERVED1) OR( 1ui64 SHL SPEI_RESERVED2)>
SPFEI_ALL_TTS_EVENTS	equ	< 0x000000000000FFFEui64 OR SPFEI_FLAGCHECK>
SPFEI_ALL_SR_EVENTS	equ	< 0x001FFFFC00000000ui64 OR SPFEI_FLAGCHECK>
SPFEI_ALL_EVENTS	equ	< 0xEFFFFFFFFFFFFFFFui64>
	SPFEI MACRO SPEI_ord
		local Value
		Value equ ( 1ui64 SHL SPEI_ord ) OR SPFEI_FLAGCHECK
		EXITM <Value>
		ENDM
		


SPPHRASEREPLACEMENT	STRUCT
	bDisplayAttributes BYTE ?
	pszReplacementText DWORD ?
	ulFirstElement DWORD ?
	ulCountOfElements DWORD ?
SPPHRASEREPLACEMENT		ENDS



SPSEMANTICERRORINFO	STRUCT
	ulLineNumber DWORD ?
	pszScriptLine DWORD ?
	pszSource DWORD ?
	pszDescription DWORD ?
	hrResultCode DWORD ?
SPSEMANTICERRORINFO		ENDS



SPPHRASE_50	STRUCT
	cbSize DWORD ?
	LangID WORD ?
	wHomophoneGroupId WORD ?
	ullGrammarID QWORD ?
	ftStartTime QWORD ?
	ullAudioStreamPosition QWORD ?
	ulAudioSizeBytes DWORD ?
	ulRetainedSizeBytes DWORD ?
	ulAudioSizeTime DWORD ?
	Rule SPPHRASERULE <> 
	pProperties DWORD ?
	pElements DWORD ?
	cReplacements DWORD ?
	pReplacements DWORD ?
	SREngineID GUID <> 
	ulSREnginePrivateDataSize DWORD ?
	pSREnginePrivateData DWORD ?
SPPHRASE_50		ENDS


SP_SPPHRASESIZE_500	equ	< SPPHRASE_50>
IF 0

SPPHRASE	STRUCT
	cbSize DWORD ?
	LangID WORD ?
	wReserved WORD ?
	ullGrammarID QWORD ?
	ftStartTime QWORD ?
	ullAudioStreamPosition QWORD ?
	ulAudioSizeBytes DWORD ?
	ulRetainedSizeBytes DWORD ?
	ulAudioSizeTime DWORD ?
	Rule SPPHRASERULE <> 
	pProperties DWORD ?
	pElements DWORD ?
	cReplacements DWORD ?
	pReplacements DWORD ?
	SREngineID GUID <> 
	ulSREnginePrivateDataSize DWORD ?
	pSREnginePrivateData DWORD ?
SPPHRASE		ENDS


ELSE
IFDEF SAPI_ALLOW_ENGINE_SML

SPPHRASE	STRUCT
	pSML DWORD ?
	pSemanticErrorInfo DWORD ?
SPPHRASE		ENDS


ELSE
ENDIF 
ENDIF 

SPSERIALIZEDPHRASE	STRUCT
	ulSerializedSize DWORD ?
SPSERIALIZEDPHRASE		ENDS



SPRULE	STRUCT
	pszRuleName DWORD ?
	ulRuleId DWORD ?
	dwAttributes DWORD ?
SPRULE		ENDS

        S_OK equ 0
        S_FALSE equ 00000001
        NOERROR equ 0
        E_NOTIMPL     equ 80004001h
        E_NOINTERFACE equ 80004002h
        E_POINTER     equ 80004003h
        E_ABORT       equ 80004004h
        E_FAIL        equ 80004005h
        E_HANDLE      equ 80070006h
        CLASS_E_NOAGGREGATION equ 80040110h
        E_OUTOFMEMORY equ 8007000Eh
        E_INVALIDARG  equ 80070057h
        E_UNEXPECTED  equ 8000FFFFh

SPF_DEFAULT            equ 0
SPF_ASYNC              equ 1
SPF_PURGEBEFORESPEAK   equ 2
SPF_IS_FILENAME        equ 4
SPF_IS_XML             equ 8
SPF_IS_NOT_XML         equ 16
SPF_PERSIST_XML        equ 32
SPF_NLP_SPEAK_PUNC     equ 64
SPF_NLP_MASK           equ SPF_NLP_SPEAK_PUNC
SPF_VOICE_MASK         equ SPF_ASYNC or SPF_PURGEBEFORESPEAK or SPF_IS_FILENAME or SPF_IS_XML or SPF_IS_NOT_XML or SPF_NLP_MASK or SPF_PERSIST_XML
SPF_UNUSED_FLAGS       equ NOT SPF_VOICE_MASK

SPPR_ALL_ELEMENTS	EQU -1 
SP_GETWHOLEPHRASE	equ	< SPPR_ALL_ELEMENTS>

;SPRULESTATE	UNION
	SPRS_INACTIVE	EQU 0 
	SPRS_ACTIVE	EQU 1 
	SPRS_ACTIVE_WITH_AUTO_PAUSE	EQU 3 
	SPRS_ACTIVE_USER_DELIMITED	EQU 4 
;SPRULESTATE		ENDS

;SPEVENTLPARAMTYPE	UNION
	SPET_LPARAM_IS_UNDEFINED	EQU 0 
	SPET_LPARAM_IS_TOKEN	EQU <SPET_LPARAM_IS_UNDEFINED 	+ 1 >
	SPET_LPARAM_IS_OBJECT	EQU <SPET_LPARAM_IS_TOKEN 	+ 1 >
	SPET_LPARAM_IS_POINTER	EQU <SPET_LPARAM_IS_OBJECT 	+ 1 >
	SPET_LPARAM_IS_STRING	EQU <SPET_LPARAM_IS_POINTER 	+ 1 >
;SPEVENTLPARAMTYPE		ENDS

.data
GUID_SpSharedRecognizer GUID {3BEE4890-4FE9-4A37-8C1E-5E7E12791C1F}
spi STISpRecognizer <?>
IID_SpSharedRecognizer GUID {?}
IID_Iunknown GUID <0H,0H,0H,<0C0H,0H,0H,0H,0H,0H,0H,046H>>
IID_SpeechRecognizer GUID {2D5F1C0Ch,0BD75h,4B08h,<94h,78h,3Bh,11h,0FEh,0A2h,58h,6Ch>}
IID_RecoGrammar GUID {0B6D6F79Fh,02158h,04E50h,<0B5h,0BCh,9ah,9ch,0CDh,85h,02Ah,09h>}
IID_RecoContext GUID {580AA49Dh,7E1Eh,4809h,<0B8h,0E2h,57h,0DAh,80h,61h,04h,0B8h>}

IID_SpeechRecognizer5_1 GUID {0C2B5F241h,0DAA0h,04507h,<9Eh,16h,5Ah,1Eh,0AAh,2Bh,7Ah,5Ch>}
IID_SpeechRecognizer5_0 GUID {2D5F1C0Ch,0BD75h,04B08h,<94h,78h,3Bh,11h,0FEh,0A2h,58h,6Ch>}
IID_RecoGrammar5_1 GUID {2177DB29h,7F45h,47D0h,<85h,54h,06h,7Eh,91h,0C8h,05h,02h>}

IID_ISpVoice   GUID {06C44DF74h,072B9h,04992h,<0A1h,0ECh,0EFh,099h,06Eh,004h,022h,0D4h>}
IID_ISpRecoContext GUID {580AA49Dh,7E1Eh,4809h,<0B8h,0E2h,57h,0DAh,80h,61h,04h,0B8h>}
IID_ISpRecoGrammar GUID {0B6D6F79Fh,2158h,4E50h,<0B5h,0BCh,09Ah,9Ch,0CDh,85h,2Ah,09h>}

SAPI_GUID GUID {0C866CA3Ah,32F7h,11D2h,<96h,02h,00h,0C0h,4Fh,8Eh,0E6h,28h>}
IID_RECORESULT GUID {0ED2879CFh,0CED9h,4EE6h,<0A5h,34h,0DEh,01h,91h,0D5h,46h,8Dh>}

IID_Julius_recog GUID {0C2B5F241h,0DAA0h,4507h,<9Eh,16h,5Ah,1Eh,0AAh,2Bh,7Ah,5Ch>}

sri dword 0
rcc dword 0
cgrm dword 0
vi dword 0
rri dword 0
cpri dword 0

.code

GetInterfaceFromProgId PROC pProgId:DWORD,pIID:DWORD
        LOCAL wszProgID[1024]:word
        LOCAL ppv:Dword,retour,pchaine         
        LOCAL clsid     :GUID
        
        ; Wrote by ToutEnMasm
        mov retour,0

        invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,pProgId,-1,addr wszProgID,sizeof wszProgID
        invoke CLSIDFromProgID,addr wszProgID,addr clsid
        .if eax == S_OK
                invoke CoCreateInstance,addr clsid, NULL,CLSCTX_INPROC_SERVER OR CLSCTX_INPROC_HANDLER OR CLSCTX_LOCAL_SERVER,pIID,addr ppv
                .if eax == S_OK 
					;	invoke MessageBox,0,CADD("ppv Filled"),0,0
                        push ppv
                        pop retour
                .endif
        .endif
        mov eax,retour
        RET
GetInterfaceFromProgId endp

InitSAPI proc uses esi edi 
	
	
	;invoke CoCreateInstance,addr GUID_SpSharedRecognizer,0,CLSCTX_ALL,addr GUID_SpSharedRecognizer,addr spi
	invoke GetInterfaceFromProgId,CADD("Sapi.SpSharedRecognizer.1"),addr IID_SpeechRecognizer5_1
	.if eax==0
		invoke MessageBox,0,CADD("Something was wrong"),0,0
	.else
		mov sri,eax
	.endif
	
	ret
InitSAPI endp

CreateRecoContext proc uses esi edi 
	
;	invoke GetInterfaceFromProgId,CADD("SAPI.SpSharedRecoContext.1"),addr IID_ISpRecoContext
;	.if eax==0
;		invoke MessageBox,0,CADD("Something was wrong"),0,0
;	.else
;		mov rcc,eax
;	.endif
;	
;	
;	
;	ret
	mov rcc,0
	
	mov esi,sri
	lea eax,rcc
	push eax
	mov eax,sri
	push eax
	mov esi,[esi]
	call [esi].STISpRecognizer.CreateRecoContext
	
	
	.if rcc==0
		invoke MessageBox,0,CADD("FAiled"),0,0
	.endif
	
	ret
CreateRecoContext endp

SetNotifyWindowMessage proc uses esi edi hWnd:dword,uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	push lParam
	push wParam
	push uMsg
	push hWnd
	mov esi,rcc
	push esi
	mov esi,[esi]
	call [esi].STISpRecoContext.SetNotifyWindowMessage
	
	ret
SetNotifyWindowMessage endp

SetInterest proc uses esi edi 
	LOCAL ull:qword
	
	;mov eax,SPFEI(SPEI_RECOGNITION)
	
	lea eax,ull
	push eax
	push eax
	mov esi,rcc
	push esi
	mov esi,[esi]
	call [esi].STISpRecoContext.SetInterest
	
	ret
SetInterest endp

SetDictationState proc uses esi edi nState:dword
	LOCAL buff[256]:dword
	
	push nState
	mov esi,cgrm
	push esi
	mov esi,[esi]
	call [esi].STISpRecoGrammar.SetDictationState
	
	.if eax!=0
		xchg edx,eax
		invoke dw2hex,edx,addr buff
		invoke MessageBox,0,addr buff,0,0	
	.endif
	
	ret
SetDictationState endp

CreateRecoResult proc uses esi edi
	LOCAL rr:dword
	
	invoke CoCreateInstance,addr SAPI_GUID,0,CLSCTX_INPROC_SERVER OR CLSCTX_INPROC_HANDLER OR CLSCTX_LOCAL_SERVER,addr IID_RECORESULT,addr rr
	.if eax!=S_OK
		invoke MessageBox,0,CADD("Something was wrong"),0,0
	.endif
	
	ret
CreateRecoResult endp

CreateGrammar proc uses esi edi
	LOCAL qw:qword
	LOCAL buff[256]:dword
	
;	invoke GetInterfaceFromProgId,CADD("SAPI.SpGrammarCompiler.1"),addr IID_ISpRecoGrammar
;	.if eax==0
;		invoke MessageBox,0,CADD("Something was wrong"),0,0
;	.else
;		mov cgrm,eax
;	.endif
;	ret
	
	lea eax,cgrm
	push eax
	lea eax,qw
	push 0
	push 161
	mov esi,rcc
	push esi
	mov esi,[esi]
	call [esi].STISpRecoContext.CreateGrammar
	
	.if cgrm==0
		push eax
			invoke MessageBox,0,CADD("Error creating grammar"),0,0
		pop eax
		xchg edx,eax
		invoke dw2hex,edx,addr buff
		invoke MessageBox,0,addr buff,0,0
	.endif
;	ret
	
	push 0
	push 0
	mov esi,cgrm
	push esi
	mov esi,[esi]
	call [esi].STISpRecoGrammar.LoadDictation
	
	.if eax!=0
		xchg edx,eax
		invoke dw2hex,edx,addr buff
		invoke MessageBox,0,addr buff,0,0			
	.endif
	
	push 1
	mov esi,cgrm
	push esi
	mov esi,[esi]
	call [esi].STISpRecoGrammar.SetDictationState
	
	.if eax!=0
		xchg edx,eax
		invoke dw2hex,edx,addr buff
		invoke MessageBox,0,addr buff,0,0	
	.endif
	
	
	
	ret
;	invoke PostQuitMessage,0
	invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,CADD("coffee.xml"),-1,addr buff,sizeof buff
	
	push 1
	lea eax,buff
;	push eax
	push CSTR("coffee.xml")
	mov esi,cgrm
	push esi
	mov esi,[esi]
	call [esi].STISpRecoGrammar.LoadCmdFromFile
	
	
	
	.if eax!=0
		xchg edx,eax
		invoke dw2hex,edx,addr buff
		invoke MessageBox,0,addr buff,0,0			
	.endif
	
	ret
CreateGrammar endp

WaitForNotifyEvent proc uses esi edi nDWMilliSecond:dword
	
	push nDWMilliSecond
	mov esi,rcc
	push esi
	mov esi,[esi]
	call [esi].STISpRecoContext.WaitForNotifyEvent
	
	ret
WaitForNotifyEvent endp

BlockForResult proc uses esi edi DC:dword
	LOCAL buff[256]:dword
	LOCAL logic,logic2,logic3:dword
	LOCAL s:SPEVENT
	
	mov cpri,0
	
	push 0
	lea eax,s
	push eax
	push 1
	mov eax,rcc
	push eax
	mov eax,[eax]
	call [eax].STISpRecoContext.GetEvents
	
	xor eax,eax
	movzx eax,s.eEventId
	
	xor ecx,ecx
	mov logic,ecx
	mov logic2,ecx
	mov logic3,ecx
	
	cmp eax,SPEI_RECOGNITION
	jnz no_logic
		mov logic,1
	no_logic:
	cmp eax,SPEI_FALSE_RECOGNITION
	jnz no_logic2
		mov logic2,1
	no_logic2:
	cmp eax,SPEI_HYPOTHESIS
	jnz no_logic3
		mov logic3,1
	no_logic3:
	
	mov eax,logic
	or eax,logic2
	or eax,logic3
	jz no_need
	
	movzx eax,s.elParamType
	.if eax==SPET_LPARAM_IS_OBJECT
		mov edx,s.lParam
		mov cpri,edx
		
		mov eax,cpri
		push eax
		mov eax,[eax]
		call [eax].STISpRecoResult.AddRef
		xor eax,eax
		inc eax
	;	invoke MessageBox,0,CADD("The word is ready"),0,0
	.endif	
	ret
	no_need:
	xor eax,eax
	ret
BlockForResult endp

GetText proc uses esi edi lpWChar:dword
	
	push 0
	push lpWChar
	push TRUE
	push SP_GETWHOLEPHRASE
	push SP_GETWHOLEPHRASE
	mov eax,cpri
	push eax
	mov eax,[eax]
	call [eax].STISpRecoResult.GetText
	ret
GetText endp

SpeakAudio proc uses esi edi
	
	push 0
	push -1
	push 0
	push 0
	mov eax,cpri
	push eax
	mov eax,[eax]
	call [eax].STISpRecoResult.SpeakAudio
	
	ret
SpeakAudio endp

SpeakInit proc uses esi edi
	
	invoke GetInterfaceFromProgId,CADD("SAPI.SpVoice.1"),addr IID_ISpVoice
	.if eax==0
		invoke MessageBox,0,CADD("Something was wrong"),0,0
	.else
		mov vi,eax
	.endif
	
	ret
SpeakInit endp

SpeakSetVolume proc uses esi edi nVolume:dword
	LOCAL x:dword
	;STISpVoice.SetVolume
	
	push nVolume
	mov esi,vi
	push esi
	mov esi,[esi]
	call [esi].STISpVoice.SetVolume
	
	ret
SpeakSetVolume endp

Speak proc uses esi edi lpText:dword
	LOCAL buff[256]:dword
	
	invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,lpText,-1,addr buff,sizeof buff
	
	push 0
	push SPF_DEFAULT
	lea eax,buff
	push eax
	mov esi,vi
	push esi
	mov esi,[esi]
	call [esi].STISpVoice.Speak
	.if eax!=0
;		xchg edx,eax
;		invoke dw2a,edx,addr buff
;		invoke MessageBox,0,addr buff,0,0
	.endif
	
	ret
Speak endp

SpeakShutDown proc uses esi edi 
	
	
	mov esi,vi
	push esi
	mov esi,[esi]
	call [esi].STISpVoice.Release
	
	ret
SpeakShutDown endp

ShutDownSAPI proc uses esi edi
	
	mov eax,sri
	push eax
	mov eax,[eax]
	call [eax].STISpRecognizer.Release
	
	ret
ShutDownSAPI endp
